%global namedreltag .Final
%global namedversion %{version}%{namedreltag}

Name:          resteasy
Version:       3.0.6
%define subrel 1
Release:       %mkrel 3
Group:         Development/Java
Summary:       Framework for RESTful Web services and Java applications
License:       ASL 2.0 and CDDL
URL:           http://www.jboss.org/resteasy
Source0:       https://github.com/resteasy/Resteasy/archive/%{namedversion}.tar.gz

# Support for mime4j 0.7.2
Patch0:        0001-Mime4j-0.7.2-support.patch
Patch1:        0002-bcmail-api-change.patch
Patch2:        0003-resteasy-cve-2014-3490.patch
Patch3:        resteasy-3.0.6.Final-resteasy-1280539.patch
Patch4:        resteasy-3.0.6.Final-resteasy-1357624.patch
Patch5:        resteasy-3.0.6.Final-resteasy-1378619.patch

BuildArch:     noarch

BuildRequires: apache-commons-lang
BuildRequires: apache-commons-cli
BuildRequires: apache-commons-codec
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-collections
BuildRequires: apache-mime4j >= 0:0.7.2-2
BuildRequires: apache-james-project

BuildRequires: bea-stax
BuildRequires: bean-validation-api
#BuildRequires: bouncycastle
BuildRequires: bouncycastle-mail
BuildRequires: cglib
BuildRequires: classmate
BuildRequires: codehaus-parent
BuildRequires: dnsjava
BuildRequires: geronimo-annotation
BuildRequires: glassfish-jaxb >= 0:2.2.5-2
BuildRequires: glassfish-jaxb-api
BuildRequires: google-guice
BuildRequires: hibernate-validator
BuildRequires: httpcomponents-client
BuildRequires: httpcomponents-core
BuildRequires: hsqldb
BuildRequires: httpunit
BuildRequires: infinispan
BuildRequires: jackson-databind
BuildRequires: jackson-module-jaxb-annotations
BuildRequires: jackson-annotations
BuildRequires: jackson-core
BuildRequires: jackson-jaxrs-json-provider
BuildRequires: jakarta-commons-httpclient
BuildRequires: javamail
BuildRequires: javassist
BuildRequires: jandex
BuildRequires: jboss-servlet-2.5-api
BuildRequires: jboss-servlet-3.0-api
BuildRequires: jcip-annotations
BuildRequires: jettison
BuildRequires: jetty-server
BuildRequires: junit
BuildRequires: jsonp
BuildRequires: netty
BuildRequires: scannotation
BuildRequires: slf4j
BuildRequires: snakeyaml
BuildRequires: glassfish-fastinfoset
BuildRequires: tomcat-el-2.2-api
BuildRequires: cdi-api
BuildRequires: xerces-j2
BuildRequires: picketbox
BuildRequires: springframework-webmvc
BuildRequires: jetty-version-maven-plugin
BuildRequires: maven-local
BuildRequires: maven-compiler-plugin
BuildRequires: maven-deploy-plugin
BuildRequires: maven-install-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-jaxb2-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-pmd-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-report-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: mvn(com.github.jnr:jffi::native:)
BuildRequires: mvn(com.headius:options)
BuildRequires: jboss-annotations-1.1-api
BuildRequires: undertow

%description
RESTEasy contains a JBoss project that provides frameworks to help
build RESTful Web Services and RESTful Java applications. It is a fully
certified and portable implementation of the JAX-RS specification. 

%package       javadoc
Summary:       Javadocs for %{name}
Group:         Documentation

%description   javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n Resteasy-%{namedversion}

# Disable unnecesary modules
%pom_disable_module examples jaxrs/pom.xml
%pom_disable_module profiling-tests jaxrs/pom.xml
%pom_disable_module resteasy-test-data jaxrs/pom.xml
%pom_disable_module war-tests jaxrs/pom.xml
%pom_disable_module resteasy-links jaxrs/pom.xml
%pom_disable_module jboss-modules jaxrs/pom.xml

%pom_disable_module resteasy-oauth jaxrs/security/pom.xml
%pom_disable_module login-module-authenticator jaxrs/security/pom.xml
%pom_disable_module skeleton-key-idm jaxrs/security/pom.xml
%pom_disable_module keystone/keystone-as7 jaxrs/security/pom.xml
%pom_disable_module keystone/keystone-as7-modules jaxrs/security/pom.xml

%pom_disable_module async-http-servlet-3.0-test jaxrs/async-http-servlet-3.0/pom.xml
%pom_disable_module callback-test jaxrs/async-http-servlet-3.0/pom.xml
# HV 4.3
%pom_disable_module resteasy-hibernatevalidator-provider jaxrs/providers/pom.xml

# Leave Netty 4, disable Netty 3
%pom_disable_module resteasy-netty jaxrs/server-adapters/pom.xml

# Replace 2.5 servlet with the jboss-servlet-2.5-api provides
for m in jaxrs/tjws; do
%pom_remove_dep "javax.servlet:servlet-api" ${m}/pom.xml
%pom_add_dep "org.jboss.spec.javax.servlet:jboss-servlet-api_2.5_spec" ${m}/pom.xml
done

# Need to be patched to work with Jetty 9
rm jaxrs/resteasy-spring/src/main/java/org/jboss/resteasy/springmvc/JettyLifecycleManager.java

%pom_remove_dep "org.springframework:spring-test" jaxrs/resteasy-spring/pom.xml
%pom_remove_dep "org.mortbay.jetty:jetty" jaxrs/resteasy-spring/pom.xml
%pom_add_dep "org.eclipse.jetty:jetty-server" jaxrs/resteasy-spring/pom.xml

# Fixing JDK7 ASCII issues
files='
jaxrs/resteasy-jsapi/src/main/java/org/jboss/resteasy/jsapi/JSAPIWriter.java
jaxrs/resteasy-jsapi/src/main/java/org/jboss/resteasy/jsapi/JSAPIServlet.java
jaxrs/resteasy-jsapi/src/main/java/org/jboss/resteasy/jsapi/ServiceRegistry.java
'

for f in ${files}; do
native2ascii -encoding UTF8 ${f} ${f}
done

%patch0 -p1
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
%mvn_build -f

# Create Jandex index file(s)
# Not all files are required by WildFly, but let's create indexes for all of them
find -name 'resteasy-*-%{namedversion}.jar' | while read f; do
  java -cp $(build-classpath jandex) org.jboss.jandex.Main -j ${f}
done

%install
%mvn_install

find -name "resteasy-*-jandex.jar" | while read f; do
  install -pm 644 ${f} %{buildroot}%{_javadir}/%{name}/$(basename -s "-%{namedversion}-jandex.jar" $f)-jandex.jar
done

%files -f .mfiles
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*jandex.jar
%doc jaxrs/License.html jaxrs/README.html

%files javadoc -f .mfiles-javadoc
%doc jaxrs/License.html


%changelog
* Wed Nov 16 2016 daviddavid <daviddavid> 3.0.6-3.1.mga5
+ Revision: 1067546
- P3: fix pom version
- P4: fail to build with java 8
- P5: disable SerializerProvider by default, fixes CVE-2016-7050 (mga#19718)
  * from https://git.centos.org/commit/rpms!resteasy-base.git/refs!heads!c7
  * https://rhn.redhat.com/errata/RHSA-2016-2604.html

* Fri Feb 20 2015 daviddavid <daviddavid> 3.0.6-3.mga5
+ Revision: 816128
- rebuild for new jruby, yecht and nailgun
- add missing BuildRequires on options and jffi-native
- fix Group

* Sat Dec 27 2014 pterjan <pterjan> 3.0.6-2.mga5
+ Revision: 806512
- Clean rebuild
- Sync with Fedora 21 (update to 3.0.6)
- Restore

  + sander85 <sander85>
    - Unmaintained + unfixed security issue

  + umeabot <umeabot>
    - Second Mageia 5 Mass Rebuild
    - Mageia 5 Mass Rebuild

* Wed Jan 01 2014 dmorgan <dmorgan> 3.0.1-3.mga4
+ Revision: 563743
- Rebuild against tomcat 7
- New version

  + umeabot <umeabot>
    - Mageia 4 Mass Rebuild

* Thu Jan 17 2013 dmorgan <dmorgan> 2.3.2-11.mga3
+ Revision: 389222
- Fix release
- Remove maven-anno-mojo as dep

* Wed Jan 16 2013 dmorgan <dmorgan> 2.3.2-10.mga3
+ Revision: 388684
- Fix buildrequires

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 10 2012 dmorgan <dmorgan> 2.3.2-9.mga3
+ Revision: 291566
- New version

* Mon Jun 25 2012 gil <gil> 2.3.2-1.mga3
+ Revision: 263477
- update to 2.3.2.Final
- imported package resteasy

